<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>登录页面</title>
 
    <link rel="stylesheet" type="text/css" href="/static/css/login.css"/>
    <script src="http://libs.baidu.com/jquery/2.0.0/jquery.js"></script>
    <script src="http://www.gongjuji.net/Content/files/jquery.md5.js"></script>
</head>

<body>
<div id="user_frame">
    <img src="" id="headurl" height="100" width="100">
    <p>
        <input type="file" id="ipt-file"/>
        <button type="button" id="btn_upload">上传</button>
    </p>
    <div class="progress-bar">
        <div class="progress"  id="progress"></div>
    </div>
    <p id="info"></p>

    <p><label class="label_input">用户名</label><input type="text" id="username" class="text_field"/></p>
    <p><label class="label_input">昵称</label><input type="text" id="nickname" class="text_field"/></p>
    <div id="login_control">
        <input type="button" id="btn_edit" value="修改昵称"/>
        <input type="button" id="btn_logout" value="登出"/>
     </div>
</div>
 
</body>
</html>
<script>
    function getQueryVariable(variable) {
       var query = window.location.search.substring(1);
       var vars = query.split("&");
       for (var i=0;i<vars.length;i++) {
               var pair = vars[i].split("=");
               if(pair[0] == variable){return pair[1];}
       }
       return(false);
    }
    var button = document.querySelector("#btn_upload"),
    input = document.querySelector("#ipt-file"),
    progress = document.querySelector("#progress"),
    info = document.querySelector("#info");

    var headurl = document.getElementById('headurl')
    var username = document.getElementById('username')
    from_user_id = getQueryVariable('userid')
    from_user_name = getQueryVariable('username')
    console.log("user_id:" + from_user_id)
    username.value = from_user_name
    var user_id = from_user_id
    var previousNickname
    username.setAttribute('readOnly', true)

    var data = {"user_name":username.value}

    var xhr = new XMLHttpRequest();
    xhr.open('post', 'http://localhost:8080/query_userinfo')
    xhr.setRequestHeader("Content-type", "application/json")
    xhr.setRequestHeader("Authorization", from_user_id)
    xhr.send(JSON.stringify(data))

    xhr.onreadystatechange = function () {
        if (xhr.readyState == 4) {
            var json = eval("("+xhr.responseText+")")
            console.log(xhr.responseText)
            if (xhr.status == 200) {
                username.value = json.userName
                nickname.value = json.nickName
                previousNickname = json.nickName
                if (json.picture_path != "") {
                    console.log("set picture path:" + json.pictureUrl)
                    headurl.src = json.pictureUrl
                }
            }  else if (xhr.status == 401){
                console.log(json.message)
                alert("您尚未登录，请先登录!")
                window.location.href = "http://localhost:8080/static/login.html"
            } else {
                console.log(json.message)
                alert("获取用户信息失败！")
                window.location.href = "http://localhost:8080/static/login.html"
            }
        }
    }

    btn_logout.onclick = function() {
        var xhr = new XMLHttpRequest();
        xhr.open('post', 'http://localhost:8080/api/logout/' + user_id)
        xhr.send()
        console.log("send to logout")
        xhr.onreadystatechange = function () {
            if (xhr.readyState == 4) {
                var json = eval("("+xhr.responseText+")");
                if (xhr.status == 200) {
                    alert('登出成功!')
                    window.location.href = "http://localhost:8080/static/login.html"
                } else if (xhr.status == 401){
                    console.log(json.message)
                    alert("您尚未登录，请先登录!")
                    window.location.href = "http://localhost:8080/static/login.html"
                } else {
                    alert("登出失败:" + json.message)
                }
            }
        }
    }

    btn_edit.onclick = function() {
        var newNickname = nickname.value
        if (newNickname.length < 1) {
            alert('昵称长度不能小于1')
            return
        }

        if (newNickname == previousNickname) {
            alert('昵称没有改变')
            return
        }

        // var formData = new FormData();
        // if (input.files.length === 0) {
        //     formData.append("picture", input.files[0]);
        // }
        //
        var data = {"user_name":username.value, "new_nick_name":newNickname}


        var xhr = new XMLHttpRequest();
        xhr.open('post', 'http://localhost:8080/update_nickname')
        xhr.setRequestHeader("Content-type","application/json")
        xhr.setRequestHeader("Authorization", user_id)
        xhr.send(JSON.stringify(data))
        console.log("start to update nickname")
        xhr.onreadystatechange = function () {
            if (xhr.readyState == 4) {
                var json = eval("("+xhr.responseText+")");
                if (xhr.status == 200) {
                    alert('修改成功')
                } else {
                    alert("修改失败:" + json.message)
                }
            }
        }
    }

    var upload = function() {
	if (input.files.length === 0) {
		console.log("未选择文件");
		return;
	}

	var formData = new FormData();
	formData.append("new_file", input.files[0]);

	var xhr = new XMLHttpRequest();
    // formData.append("user_name", username.value);
    xhr.open('post', 'http://localhost:8080/upload_picture?user_name='+username.value)
        // alert(input.files[0])
    xhr.setRequestHeader("Authorization", from_user_id)
    // xhr.setRequestHeader("Content-type", "multipart/form-data")
    xhr.send(formData);
	xhr.onreadystatechange = function() {
		if (xhr.readyState === 4) {
			console.log(xhr.responseText);
			var json = eval("(" + xhr.responseText + ")");
			if (xhr.status === 200) {
                alert('修改头像成功')
                // headurl.src = json.picture_path
			} else {
				alert("修改头像失败:" + json.msg)
			}
		}
	};

	xhr.upload.addEventListener("progress", function(event) {
        if(event.lengthComputable){
			progress.style.width = Math.ceil(event.loaded * 100 / event.total) + "%";
			}
			}, false);

    }
    button.addEventListener("click", upload, false);
</script>

